/*****************************************
  xjump version 2

  xjump.h   wb_( R[h֘A )

  (C) Oct 28, 1997  ROYALPANDA
*****************************************/

/* modified by shinichiro.h in 020820 */

#include "zsdl.h"

#include "replay.h"

/* L[̒` */

#define KEY_UP    0
#define KEY_LEFT  1
#define KEY_RIGHT 2


/* p */

#define DEAD -1


/* ʃTCY */

#define WIDTH  32
#define HEIGHT 24

typedef struct{

  int x;         /* W x */
  int y;         /* W y */
  int vx;        /* x x */
  int vy;        /* x y */
  int jump;      /* Wv */
  int pic;       /* OtBbN */
  int dir;       /*  */
  int g_count;   /* Aj[VpJE^ */

} hero_t;

extern int Floor_L[];
extern int Floor_R[];
extern int Map_index;

extern hero_t Hero;

extern int Is_replay;
extern replay_t Floor_replay;
extern replay_t Move_replay;

extern int Key[];

extern int Floor_top;

extern SDL_Surface* Screen;

extern SDL_Surface* Disp;

extern SDL_Surface* Floor_p;
extern SDL_Surface* Back_p;
extern SDL_Surface* Char_p;

void init_game( void );
int move( void );
void recover_scr( int x, int y, int x2, int y2 );

int is_file_exist(const char* filename);
int rnd( int range );
void srnd( void );

void query_keycode( void );
void keymap( void );
void wait_keyup( void );

/* }N */

#define floor_r(y)  Floor_R[ ( y+Map_index) % HEIGHT ]
#define floor_l(y)  Floor_L[ ( y+Map_index) % HEIGHT ]
